import { EventObject } from "./EventObject";
import { IPickerItem } from "./pickeritems/IPickerItem";
import { SearchPickerChoices } from "./SearchPickerChoices";
import { SearchPickerResults } from "./SearchPickerResults";
import { ISearchPickerOptions } from "./options/ISearchPickerOptions";
export declare class SearchPicker extends EventObject {
    private container;
    pickerItems: IPickerItem[];
    choices: SearchPickerChoices;
    results: SearchPickerResults;
    options: ISearchPickerOptions;
    private inFocus;
    private choicesElm;
    private searchTmrId;
    private isMobile;
    constructor(container: any, options: ISearchPickerOptions);
    getChoices(): IPickerItem[];
    clearChoices(): void;
    addChoice(item: IPickerItem): void;
    removeChoice(item: IPickerItem): void;
    updateSource(source: any[]): void;
    focus(): void;
    allowInput(): void;
    forbidInput(): void;
    private setupHtml;
    private bindEvents;
    private onSearch;
    private onChoiceRemoved;
    private onChoiceFocus;
    private onClick;
    private onEscape;
    private onSelect;
    private onResultSelected;
    private applyTemplate;
    private extendOptions;
}
export declare function isMobile(): boolean;
