"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DefaultPickerItem_1 = require("../pickeritems/DefaultPickerItem");
var Utils_1 = require("../Utils");
var DefaultSearcher_1 = require("../searchers/DefaultSearcher");
var DefaultSearchPickerOptions = /** @class */ (function () {
    function DefaultSearchPickerOptions() {
        this.source = [];
        this.placeholder = '';
        this.maxSelectedChoices = 0;
        this.minLengthToSearch = 1;
        this.searchInValues = false;
        //Представление элемента
        this.pickerItemFactory = function (item) {
            return DefaultPickerItem_1.DefaultPickerItem.create(item.id, item.title);
        };
        this.resultRenderer = function (item, query) {
            var root = document.createElement('a');
            root.setAttribute('href', '#');
            var textNodes = Utils_1.Utility.wrapResultText(item.title, query);
            for (var i = 0; i < textNodes.length; i++) {
                root.appendChild(textNodes[i]);
            }
            return root;
        };
        this.noResultsRenderer = function (query) {
            return document.createTextNode('No results found for "' + Utils_1.Utility.htmlEncode(query) + '"');
        };
        this.choiceRenderer = function (item, renderClose) {
            var choice = document.createElement('span');
            choice.appendChild(document.createTextNode(item.title));
            if (renderClose) {
                var close_1 = document.createElement('a');
                close_1.href = 'javascript: void(0);';
                close_1.className = 'search-choice-close';
                choice.appendChild(close_1);
            }
            return choice;
        };
        this.searcher = new DefaultSearcher_1.DefaultSearcher();
        this.resultFooterRenderer = null;
    }
    return DefaultSearchPickerOptions;
}());
exports.DefaultSearchPickerOptions = DefaultSearchPickerOptions;
//# sourceMappingURL=DefaultSearchPickerOptions.js.map