"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Utils_1 = require("../Utils");
var SlowedSearcher = /** @class */ (function () {
    function SlowedSearcher() {
        this.pickerItems = null;
        this.foundItems = [];
    }
    SlowedSearcher.prototype.search = function (query, options, onresults, onerror) {
        var _this = this;
        if (this.tmrId)
            clearTimeout(this.tmrId);
        this.tmrId = setTimeout(function () {
            if (!_this.pickerItems) //TODO updating...
                _this.pickerItems = _this.$map(options.source, options);
            _this.foundItems = Utils_1.Utility.filterItems(_this.pickerItems, query, options);
            _this.tmrId = null;
            onresults(_this.foundItems);
        }, 1000);
    };
    SlowedSearcher.prototype.$map = function (source, options) {
        var result = [];
        for (var i = 0; i < source.length; i++) {
            result.push(options.pickerItemFactory(source[i]));
        }
        return result;
    };
    return SlowedSearcher;
}());
exports.SlowedSearcher = SlowedSearcher;
//# sourceMappingURL=SlowedSearcher.js.map